#/bin/bash
set -eu -o pipefail # See: https://sipb.mit.edu/doc/safe-shell/

ctags -n --if0=yes --langmap=c++:+.inl --c++-kinds=+p --file-tags=yes -R --extra=fq \
    --exclude='obj/*' \
    --exclude='lib/*' \
    --exclude='*generated/*'

find . -mindepth 1 \
        '(' -path './include' ')' -prune \
    -or '(' -path './lib' ')' -prune \
    -or '(' -path '*/generated' ')' -prune \
    -or '(' -type d ')' -print | while read i
do
    pushd "$i" 1> /dev/null
    ctags -n --if0=yes --langmap=c++:+.inl --c++-kinds=+p --file-tags=yes -R --extra=fq \
        --exclude='obj/*' \
        --exclude='lib/*' \
        --exclude='*generated/*'
    popd 1> /dev/null
done

# Finally, there'll be empty tags files, unlink those
find . -name tags -size -2 -print | xargs rm
