#include <iostream>
#include <mutex>
#include <set>

#include "scoped_set_adder.hpp"
 
namespace {
    std::mutex g_mutex;
    std::set<scoped_set_adder *> g_items;
}
 
scoped_set_adder::scoped_set_adder(std::string const& name) : name_(name) {
    std::lock_guard<std::mutex> lock(g_mutex);
    g_items.insert(this);
}
 
scoped_set_adder::~scoped_set_adder() {
    std::lock_guard<std::mutex> lock(g_mutex);
    g_items.erase(this);
}
 
bool scoped_set_adder::dump() const {
    std::lock_guard<std::mutex> lock(g_mutex);
    bool ret = (g_items.size() > 0);
    std::cout << "suppressed " << ret << " count " << g_items.size() << std::endl;
    return ret;
}
